package com.zhongshu.card.server.core.dao.school.impl;

import com.github.microservice.components.data.mongo.mongo.helper.DBHelper;
import com.zhongshu.card.client.model.school.BookInfoSearch;
import com.zhongshu.card.server.core.dao.BaseImpl;
import com.zhongshu.card.server.core.dao.school.extend.BookInfoDaoExtend;
import com.zhongshu.card.server.core.domain.org.Department;
import com.zhongshu.card.server.core.domain.school.BookInfo;
import com.zhongshu.card.server.core.util.CommonUtil;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

/**
 * @Author TRX
 * @CreateDate: 2023/4/12
 * @Version: 1.0
 */
public class BookInfoDaoImpl extends BaseImpl implements BookInfoDaoExtend {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Autowired
    private DBHelper dbHelper;

    @Override
    public Page<BookInfo> page(Pageable pageable, BookInfoSearch param) {
        Criteria criteria = new Criteria();

        // 学校ID
        if (ObjectUtils.isNotEmpty(param.getOid())) {
            criteria.and("oid").is(param.getOid());
        }

        if (param.getUserType() != null) {
            criteria.and("userType").is(param.getUserType());
        }

        if (StringUtils.isNotEmpty(param.getDepartmentId())) {
            criteria.and("department").is(Department.build(param.getDepartmentId()));
        }

        if (param.getSex() != null) {
            criteria.and("sex").is(param.getSex());
        }

        // 入学年份
        if (CommonUtil.longIsEmpty(param.getInSchoolYear())) {
            criteria.and("inSchoolYear").is(param.getInSchoolYear());
        }

        // 状态
        if (param.getBookState() != null) {
            criteria.and("bookState").is(param.getBookState());
        }

        if (!CommonUtil.longIsEmpty(param.getStartTime()) && !CommonUtil.longIsEmpty(param.getEndTime())) {
            criteria.and("createTime").gte(param.getStartTime()).and("createTime").lte(param.getEndTime());
        }

        // 模糊搜索
        List<Criteria> criterias = new ArrayList<>();
        if (StringUtils.isNotEmpty(param.getName())) {
            Pattern pattern = Pattern.compile("^.*" + param.getName() + ".*$");
            criterias.add(Criteria.where("name").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getPhone())) {
            Pattern pattern = Pattern.compile("^.*" + param.getPhone() + ".*$");
            criterias.add(Criteria.where("phone").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getIdCard())) {
            Pattern pattern = Pattern.compile("^.*" + param.getIdCard() + ".*$");
            criterias.add(Criteria.where("idCard").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getCode())) {
            Pattern pattern = Pattern.compile("^.*" + param.getCode() + ".*$");
            criterias.add(Criteria.where("code").is(pattern));
        }

        if (StringUtils.isNotEmpty(param.getClassName())) {
            Pattern pattern = Pattern.compile("^.*" + param.getClassName() + ".*$");
            criterias.add(Criteria.where("className").is(pattern));
        }
        if (!CollectionUtils.isEmpty(criterias)) {
            criteria.andOperator(criterias.toArray(new Criteria[]{}));
        }

        if (StringUtils.isNotEmpty(param.getKeyWord())) {
            Pattern pattern = Pattern.compile("^.*" + param.getKeyWord() + ".*$");
            criteria.orOperator(Criteria.where("name").regex(pattern), Criteria.where("phone").regex(pattern));
        }


        criteria.and("isDelete").is(Boolean.FALSE);

        Sort sort = buildSort(param);
        Query query = Query.query(criteria);
        query.with(sort);
        return dbHelper.pages(query, pageable, BookInfo.class);
    }

}
